From db44775d301868cb450ee74132df25ce522a04b8 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:39 +0000
Subject: [PATCH 813/2232] Use relative paths as provided by caller's build.rs


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index ef075c1..bdaf4f6 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -143,11 +143,11 @@ fn generate_bridge(prj: &Project, build: &mut Build, rust_source_file: &Path) ->
     let opt = Opt::default();
     let generated = gen::generate_from_path(rust_source_file, &opt);
 
-    let header_path = paths::out_with_extension(prj, rust_source_file, ".h")?;
+    let header_path = paths::out_with_extension(prj, rust_source_file, ".h");
     write(&header_path, &generated.header)?;
     paths::symlink_header(prj, &header_path, rust_source_file);
 
-    let implementation_path = paths::out_with_extension(prj, rust_source_file, ".cc")?;
+    let implementation_path = paths::out_with_extension(prj, rust_source_file, ".cc");
     write(&implementation_path, &generated.implementation)?;
     build.file(&implementation_path);
     Ok(())
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index f8b1ee9..fc06157 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -34,8 +34,7 @@ pub(crate) fn symlink_header(prj: &Project, path: &Path, original: &Path) {
 }
 
 fn try_symlink_header(prj: &Project, path: &Path, original: &Path) -> Result<()> {
-    let suffix = relative_to_parent_of_target_dir(prj, original)?;
-    let ref dst = include_dir(prj).join(suffix);
+    let ref dst = include_dir(prj).join(original);
 
     fs::create_dir_all(dst.parent().unwrap())?;
     let _ = fs::remove_file(dst);
@@ -49,29 +48,14 @@ fn try_symlink_header(prj: &Project, path: &Path, original: &Path) -> Result<()>
     Ok(())
 }
 
-fn relative_to_parent_of_target_dir(prj: &Project, original: &Path) -> Result<PathBuf> {
-    let mut outer = match &prj.target_dir {
-        TargetDir::Path(target_dir) => target_dir.parent().unwrap(),
-        TargetDir::Unknown => unimplemented!(), // FIXME
-    };
-    let original = canonicalize(original)?;
-    loop {
-        if let Ok(suffix) = original.strip_prefix(outer) {
-            return Ok(suffix.to_owned());
-        }
-        match outer.parent() {
-            Some(parent) => outer = parent,
-            None => return Ok(original.components().skip(1).collect()),
-        }
-    }
-}
-
-pub(crate) fn out_with_extension(prj: &Project, path: &Path, ext: &str) -> Result<PathBuf> {
-    let mut file_name = path.file_name().unwrap().to_owned();
+pub(crate) fn out_with_extension(prj: &Project, rel_path: &Path, ext: &str) -> PathBuf {
+    let mut file_name = rel_path.file_name().unwrap().to_owned();
     file_name.push(ext);
 
-    let rel = relative_to_parent_of_target_dir(prj, path)?;
-    Ok(prj.out_dir.join(rel).with_file_name(file_name))
+    prj.out_dir
+        .join("cxxbridge")
+        .join(rel_path)
+        .with_file_name(file_name)
 }
 
 pub(crate) fn include_dir(prj: &Project) -> PathBuf {
@@ -109,20 +93,6 @@ pub(crate) fn search_parents_for_target_dir(out_dir: &Path) -> TargetDir {
     }
 }
 
-#[cfg(not(windows))]
-fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
-    Ok(fs::canonicalize(path)?)
-}
-
-#[cfg(windows)]
-fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
-    // Real fs::canonicalize on Windows produces UNC paths which cl.exe is
-    // unable to handle in includes. Use a poor approximation instead.
-    // https://github.com/rust-lang/rust/issues/42869
-    // https://github.com/alexcrichton/cc-rs/issues/169
-    Ok(fs::current_dir()?.join(path))
-}
-
 #[cfg(unix)]
 use self::fs::symlink_file as symlink_or_copy;
 
diff --git a/gen/src/fs.rs b/gen/src/fs.rs
index 77488f8..fe15f86 100644
--- a/gen/src/fs.rs
+++ b/gen/src/fs.rs
@@ -34,14 +34,6 @@ macro_rules! err {
     }
 }
 
-pub(crate) fn canonicalize(path: impl AsRef<Path>) -> Result<PathBuf> {
-    let path = path.as_ref();
-    match std::fs::canonicalize(path) {
-        Ok(string) => Ok(string),
-        Err(e) => err!(e, "Unable to canonicalize path: `{}`", path),
-    }
-}
-
 pub(crate) fn copy(from: impl AsRef<Path>, to: impl AsRef<Path>) -> Result<u64> {
     let from = from.as_ref();
     let to = to.as_ref();

